#!/usr/bin/python

import sys

# a module to process JSON files
import json

# a module with mathematical functions
import math

def main():

    # We pass to the program through standard input a JSON file with parameter
    # values. In our case it is a very simple JSON file with key-value pairs.
    # A specific value is assigned to each parameter. The parameters are used 
    # for estimating the cost of the most efficient evaluation of seven queries.
    # 
    # We use different value types for the parameters in the JSON file: 
    # - integers, 
    # - strings,
    # - lists containing two integers. 
    # For examples of how to read the parameter values from the JSON file, go 
    # to the comments in method 'query1(params, a)'.
    params = json.load(sys.stdin)

    # Read the query type as an argument of our program.
    # Depending on the query type, read also one or two attribute values.
    querytype = sys.argv[1]
    if querytype == "1":
        # Q1: A = a
        a = int(sys.argv[2])
        res = query1(params, a)
    elif querytype == "2":
        # Q2: A >= a
        a = int(sys.argv[2])
        res = query2(params, a)
    elif querytype == "3":
        # Q3: A <= a
        a = int(sys.argv[2])
        res = query3(params, a)
    elif querytype == "4":
        # Q4: A < a || b < A
        a = int(sys.argv[2])
        b = int(sys.argv[3])
        res = query4(params, a, b)
    elif querytype == "5":
        # Q5: a < A && A < b
        a = int(sys.argv[2])
        b = int(sys.argv[3])
        res = query5(params, a, b)
    elif querytype == "6":
        # Q6: A < a && B > b
        a = int(sys.argv[2])
        b = int(sys.argv[3])
        res = query6(params, a, b)
    elif querytype == "7":
        # Q7: A = a && B < b
        a = int(sys.argv[2])
        b = int(sys.argv[3])
        res = query7(params, a, b)
    else:
        # Provided argument doesn't match any query type.
        raise Exception("Unknown query type %d" % querytype)

    # Print the output.
    print int(res)


# For given parameters 'params' and value 'a' of attribute A, calculate the 
# minimum number of blocks that have to be read to answer the query of type
# 
# Q1: A = a
# 
def query1(params, a):

    # Examples of how to read values of parameters from a JSON file.
    # 
    # Remember that we've already read the contents of a JSON file to the
    # variable 'params' (first line of method 'main()'). We access it similarly 
    # to accessing a hash map.
    # 
    # Example 1: Assign the value of integer parameter 'relsize' to variable 
    #            'relation_size'.
    # 
    #            relation_size = params["relsize"] 
    # 
    # Example 2: Verify if the value of string parameter 'indexA' equals 'sparse'.
    # 
    #            params["indexA"] == "sparse" 
    # 
    # Example 3: Assign the elements of an integer-list parameter 'rangeA' 
    #            (the list has only two elements) to variables 'low' and 'high'. 
    #
    #            low = params["rangeA"][0] 
    #            high = params["rangeA"][1]
    #    
    # Examples of how to use mathematical functions from module 'math' that may
    # be useful in this assignment.
    # 
    # Example 1: Calculate the floor of the result of dividing two integers 'x'
    #            and 'y'. Division of integers in python returns integer value.
    #            In order to get a float result, one of the values must be float
    #            (use float() function or add '.0' to a constant, e.g. 2.0).
    # 
    #            math.floor(x / y) 
    # 
    # Example 2: Calculate the ceiling of the result of multiplying two integers
    #            'x' and 'y'. Conversion from integer to float, done with 
    #            'float()' is required for the method 'ceil()'.
    # 
    #            math.ceil(float(x * y)) 
    #
    # Example 3: Calculate the natural logarithm (base e) of 'x'. For a different
    #            base, use properties of the logarithm function.
    # 
    #            math.log(x)

    
    raise Exception("Not implemented.")

# For given parameters 'params' and value 'a' of attribute A, calculate the 
# minimum number of blocks that have to be read to answer the query of type
# 
# Q2: A >= a
# 
def query2(params, a):   
    raise Exception("Not implemented.")
        
# For given parameters 'params' and value 'a' of attribute A, calculate the 
# minimum number of blocks that have to be read to answer the query of type
# 
# Q3: A <= a
# 
def query3(params, a):
    raise Exception("Not implemented.")

# For given parameters 'params' and value 'a' of attribute A, calculate the 
# minimum number of blocks that have to be read to answer the query of type
# 
# Q4 : A < a || b < A
# 
def query4(params, a, b):
    raise Exception("Not implemented.")

# For given parameters 'params' and value 'a' of attribute A, calculate the 
# minimum number of blocks that have to be read to answer the query of type
#     
# Q5 : a < A && A < b
# 
def query5(params, a, b):
    raise Exception("Not implemented.")

# For given parameters 'params' and value 'a' of attribute A, calculate the 
# minimum number of blocks that have to be read to answer the query of type
# 
# Q6 : A < a && B > b
# 
def query6(params, a, b):
    raise Exception("Not implemented.")

# For given parameters 'params' and value 'a' of attribute A, calculate the 
# minimum number of blocks that have to be read to answer the query of type
# 
# Q7 : A = a && B < b
# 
def query7(params, a, b):
    raise Exception("Not implemented.")

# Execute main function if not imported as module.
if __name__ == "__main__":
    main()
